5 USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way] <mbox>
6 or, when resuming [--skip | --resolved]'
10 echo "$1" >"$dotest/next"
15 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
16 "$dotest/patch" "$dotest/info"
17 echo "$next" >"$dotest/next"
22 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
24 rm -fr "$dotest"/patch-merge-*
25 mkdir "$dotest/patch-merge-tmp-dir"
27 # First see if the patch records the index info that we can use.
28 if git-apply -z --index-info "$dotest/patch" \
29 >"$dotest/patch-merge-index-info" 2>/dev/null &&
30 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
31 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
32 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
33 git-write-tree >"$dotest/patch-merge-base+" &&
34 # index has the base tree now.
36 cd "$dotest/patch-merge-tmp-dir" &&
37 GIT_INDEX_FILE="../patch-merge-tmp-index" \
38 GIT_OBJECT_DIRECTORY="$O_OBJECT" \
39 git-apply $binary --index <../patch
42 echo Using index info to reconstruct a base tree...
43 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
44 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
46 # Otherwise, try nearby trees that can be used to apply the
51 # Hoping the patch is against our recent commits...
52 git-rev-list --max-count=$N HEAD
54 # or hoping the patch is against known tags...
55 git-ls-remote --tags .
59 # See if we have it as a tree...
60 git-cat-file tree "$base" >/dev/null 2>&1 || continue
62 rm -fr "$dotest"/patch-merge-* &&
63 mkdir "$dotest/patch-merge-tmp-dir" || break
65 cd "$dotest/patch-merge-tmp-dir" &&
66 GIT_INDEX_FILE=../patch-merge-tmp-index &&
67 GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
68 export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
69 git-read-tree "$base" &&
70 git-apply $binary --index &&
71 mv ../patch-merge-tmp-index ../patch-merge-index &&
72 echo "$base" >../patch-merge-base
73 ) <"$dotest/patch" 2>/dev/null && break
77 test -f "$dotest/patch-merge-index" &&
78 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
79 orig_tree=$(cat "$dotest/patch-merge-base") &&
80 rm -fr "$dotest"/patch-merge-* || exit 1
82 echo Falling back to patching base and 3-way merge...
84 # This is not so wrong. Depending on which base we picked,
85 # orig_tree may be wildly different from ours, but his_tree
86 # has the same set of wildly different changes in parts the
87 # patch did not touch, so resolve ends up cancelling them,
88 # saying that we reverted all those changes.
90 git-merge-resolve $orig_tree -- HEAD $his_tree || {
91 echo Failed to merge in the changes.
97 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary=
99 while case "$#" in 0) break;; esac
102 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
103 dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
104 -d|--d|--do|--dot|--dote|--dotes|--dotest)
105 case "$#" in 1) usage ;; esac; shift
108 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
109 --interacti|--interactiv|--interactive)
110 interactive=t; shift ;;
112 -b|--b|--bi|--bin|--bina|--binar|--binary)
115 -3|--3|--3w|--3wa|--3way)
117 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
119 -u|--u|--ut|--utf|--utf8)
121 -k|--k|--ke|--kee|--keep)
124 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
139 # If the dotest directory exists, but we have finished applying all the
140 # patches in them, clear it out.
141 if test -d "$dotest" &&
142 last=$(cat "$dotest/last") &&
143 next=$(cat "$dotest/next") &&
145 test "$next" -gt "$last"
152 test ",$#," = ",0," ||
153 die "previous dotest directory $dotest still exists but mbox given."
156 # Make sure we are not given --skip nor --resolved
157 test ",$skip,$resolved," = ,,, ||
158 die "we are not resuming."
161 mkdir -p "$dotest" || exit
163 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
168 # -b, -s, -u and -k flags are kept for the resuming session after
170 # -3 and -i can and must be given when resuming.
171 echo "$binary" >"$dotest/binary"
172 echo "$sign" >"$dotest/sign"
173 echo "$utf8" >"$dotest/utf8"
174 echo "$keep" >"$dotest/keep"
175 echo 1 >"$dotest/next"
180 files=$(git-diff-index --cached --name-only HEAD) || exit
181 if [ "$files" ]; then
182 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
187 if test "$(cat "$dotest/binary")" = t
189 binary=--allow-binary-replacement
191 if test "$(cat "$dotest/utf8")" = t
195 if test "$(cat "$dotest/keep")" = t
199 if test "$(cat "$dotest/sign")" = t
201 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
203 s/^/Signed-off-by: /'
209 last=`cat "$dotest/last"`
210 this=`cat "$dotest/next"`
213 this=`expr "$this" + 1`
217 if test "$this" -gt "$last"
224 while test "$this" -le "$last"
226 msgnum=`printf "%0${prec}d" $this`
227 next=`expr "$this" + 1`
228 test -f "$dotest/$msgnum" || {
234 # If we are not resuming, parse and extract the patch information
235 # into separate files:
236 # - info records the authorship and title
237 # - msg is the rest of commit log message
238 # - patch is the patch body.
240 # When we are resuming, these files are either already prepared
241 # by the user, or the user can tell us to do so by --resolved flag.
244 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
245 <"$dotest/$msgnum" >"$dotest/info" ||
247 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
251 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
252 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
253 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
255 if test -z "$GIT_AUTHOR_EMAIL"
257 echo "Patch does not have a valid e-mail address."
261 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
263 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
264 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
268 if test '' != "$SIGNOFF"
271 sed -ne '/^Signed-off-by: /p' \
272 "$dotest/msg-clean" |
276 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
277 test '' = "$LAST_SIGNED_OFF_BY" && echo
285 if test -s "$dotest/msg-clean"
288 cat "$dotest/msg-clean"
290 if test '' != "$ADD_SIGNOFF"
294 } >"$dotest/final-commit"
297 case "$resolved,$interactive" in
299 # This is used only for interactive view option.
300 git-diff-index -p --cached HEAD >"$dotest/patch"
306 if test "$interactive" = t
309 die "cannot be interactive without stdin connected to a terminal."
311 while test "$action" = again
313 echo "Commit Body is:"
314 echo "--------------------------"
315 cat "$dotest/final-commit"
316 echo "--------------------------"
317 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
321 [aA]*) action=yes interactive= ;;
322 [nN]*) action=skip ;;
323 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
326 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
334 if test $action = skip
340 if test -x "$GIT_DIR"/hooks/applypatch-msg
342 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
347 echo "Applying '$SUBJECT'"
352 git-apply $binary --index "$dotest/patch"
356 # Resolved means the user did all the hard work, and
357 # we do not have to do any patch application. Just
358 # trust what the user has in the index file and the
365 if test $apply_status = 1 && test "$threeway" = t
369 # Applying the patch to an earlier tree and merging the
370 # result may have produced the same tree as ours.
371 changed="$(git-diff-index --cached --name-only -z HEAD)"
372 if test '' = "$changed"
374 echo No changes -- Patch already applied.
378 # clear apply_status -- we have successfully merged.
382 if test $apply_status != 0
384 echo Patch failed at $msgnum.
388 if test -x "$GIT_DIR"/hooks/pre-applypatch
390 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
393 tree=$(git-write-tree) &&
394 echo Wrote tree $tree &&
395 parent=$(git-rev-parse --verify HEAD) &&
396 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
397 echo Committed: $commit &&
398 git-update-ref HEAD $commit $parent ||
401 if test -x "$GIT_DIR"/hooks/post-applypatch
403 "$GIT_DIR"/hooks/post-applypatch